config/routes.rb
Rails.application.routes.draw do
  root 'welcome#index'

  resources :tournaments, only: [:new, :create] do
    resources :groups, only: :create do
      post 'generate_results', on: :member
      # resources :results, only: :create
    end
  end
  resources :fakes, only: :create


  delete 'clean', to: 'clean#destroy'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/game.rb
class Game < ApplicationRecord

  TEAMS_IN_GAME = 2.freeze

  belongs_to :group
  has_many :participants, dependent: :destroy
  has_many :teams, through: :participants

  def finished?
    participants.pluck(:score).compact.size == TEAMS_IN_GAME
  end

  def winner_team
    participants.max_by(&:score).team
  end

  def draw?
    participants.first.score == participants.last.score
  end

  def distribute_scores
    draw? ? distribute_draw_scores : distribute_winner_scores
  end

  private

  def distribute_draw_scores
    participants.each { |p| p.team.get_draw_score }
  end

  def distribute_winner_scores
    winner_team.get_winner_score
  end
end

app/models/group.rb
class Group < ApplicationRecord
  has_and_belongs_to_many :teams
  has_many :games, dependent: :destroy
  belongs_to :tournament

  enum stage: %i(division play_off final)

  def best_four_teams
    teams.order(score: :desc).first(4)
  end

  def finished?
    games.any?(&:finished?)
  end

  def winners
    games.map(&:winner_team)
  end

end

app/models/participant.rb
class Participant < ApplicationRecord
  after_update :distribute_game_scores, if: Proc.new { |participant| participant.game.finished? }
  belongs_to :game
  belongs_to :team

  def opponent
    game.participants.where.not(participant: self).first
  end

  def distribute_game_scores
    game.distribute_scores
  end
end

app/models/team.rb
class Team < ApplicationRecord
  belongs_to :tournament
  has_and_belongs_to_many :groups
  has_many :participants, dependent: :destroy
  has_many :games, through: :participants

  # When the team wins a game it gets 3 points
  def get_winner_score
    self.score += 3
    save!
  end

  # When the team played a draw it gets 1 point
  def get_draw_score
    self.score += 1
    save!
  end

end

app/models/tournament.rb
class Tournament < ApplicationRecord
  include AASM

  SCALE = 16.freeze
  DIVISIONS_SCALE = 8.freeze
  DIVISION_NAMES = %w(Division\ A Division\ B).freeze
  PLAY_OFF_NAMES = %w(Play_off).freeze
  FINAL_NAMES = %w(1/2 Super\ Final).freeze

  has_many :teams, dependent: :destroy
  has_many :groups, dependent: :destroy
  accepts_nested_attributes_for :teams, reject_if: lambda { |team| team[:name].blank? }, allow_destroy: true

  validates :name, presence: true
  validate :check_teams_number

  aasm column: 'stage' do
    state :initial, initial: true
    state :division
    state :play_off
    state :final

    event :start do
      transitions from: :initial, to: :division
    end
    event :to_play_off do
      transitions from: :division, to: :play_off
    end
    event :to_final do
      transitions from: :play_off, to: :final
    end
  end

  def divisions
    groups.where(stage: Group.stages[:division])
  end

  def current_groups
    current_stage_groups.reject(&:finished?)
  end

  def current_stage_groups
    groups.where(stage: Group.stages[stage.to_sym])
  end

  private

  def teams_count_valid?
    teams.size == SCALE
  end

  def check_teams_number
      errors.add(:base, 'teams scale must be equal to', count: SCALE) unless teams_count_valid?
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/clean_controller.rb
class CleanController < ApplicationController
  def destroy
    ApplicationRecord.transaction do
      Tournament.destroy_all
      Team.destroy_all
    end
    redirect_to root_path, notice: 'Tournament and its data have been successfully destroyed.'
  end
end

app/controllers/fakes_controller.rb
class FakesController < ApplicationController
  def create
    FakeCreator.new.call
    redirect_to root_path
  end
end

app/controllers/groups_controller.rb
class GroupsController < ApplicationController
  def create
    @tournament = Tournament.find(params[:tournament_id])
    result = StageCreator.call(division_stage_packet)
    if result.success?
      redirect_to root_path, notice: 'Groups were successfully created.'
    else
      logger.info result.message
      redirect_to root_path, notice: 'Groups were not created. Things look blue'
    end
  end

  def generate_results
    @group = Group.find(params[:id])
    GameScoresGenerator.call(@group.games)
    redirect_to root_path, notice: 'Results were successfully generated.'
  end

  private

  def division_stage_packet
    {
        tournament: @tournament
    }
  end
end

app/controllers/tournaments_controller.rb
class TournamentsController < ApplicationController
  before_action :set_tournament, only: :show

  def index
    @tournaments = Tournament.all
  end

  def new
    @tournament = Tournament.new
  end

  def create
    @tournament = Tournament.new(tournament_params)

    respond_to do |format|
      if @tournament.save
        @tournament.start!
        format.html { redirect_to root_path, notice: 'Tournament was successfully created.' }
      else
        format.html { render :new }
      end
    end
  end

  private

  def set_tournament
    @tournament = Tournament.find(params[:id])
  end

  def tournament_params
    params.require(:tournament).permit(:name, teams_attributes: [:id, :name, :_destroy])
  end
end

app/controllers/welcome_controller.rb
class WelcomeController < ApplicationController
  def index
    @tournament = Tournament.includes(groups: { games: { participants: :team } })
                            .order('groups.id')
                            .includes(:teams)
                            .last
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/welcome_helper.rb
module WelcomeHelper
  def group_can_be_generated?(tournament)
    tournament.groups.first.try(:games).try(:size) != 1 and tournament.groups.first(2).all?(&:finished?)
  end
end

app/views/games/_game.html.erb
<table class="table table-hover table-dark" style="max-width: 100%">
  <tbody>
  <% if game.participants.first.present? %>
    <tr>
      <th colspan="2" class="text-center"><%= game.participants.first.score || '-' %>:<%= game.participants.last.score || '-' %></th>
    </tr>
    <tr style="height: 100px">
      <td scope="row"><%= game.participants.first.team.name %></td>
      <td scope="row"><%= game.participants.last.team.name %></td>
    </tr>
  <% end %>
  </tbody>
</table>

app/views/groups/_group.html.erb
<div class="col-12 col-md-3">
  <h3><%= group.name %> <%= link_to 'Generate results', generate_results_tournament_group_path(group.tournament.id, group.id), method: :post, class: 'btn btn-sm btn btn-outline-success' unless group.finished? %></h3>
    <% group.games.each do |game| %>
        <%= render game %>
    <% end %>
</div>

app/views/layouts/_header.html.erb
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
  <%= link_to 'Schedule', root_path, class: 'navbar-brand' %>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  <div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="navbar-nav mr-auto">
    </ul>
  </div>
</nav>

app/views/layouts/_welcome_jumbotron.html.erb
<div class="jumbotron">
  <h1 class="display-4">Hello!</h1>
  <p class="lead">Create or generate first tournament to begin.</p>
  <p class="lead">
    <%= link_to 'Generate', fakes_path, method: :post, class: 'btn btn-primary btn-lg' %>
    <%= link_to 'Create', new_tournament_path, class: 'btn btn-primary btn-lg' %>
  </p>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>TournamentSchedule</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= render 'layouts/header' %>
    <div class="container">
      <p id="notice"><%= notice %></p>
      <%= yield %>
    </div>
  </body>
</html>

app/views/tournaments/_form.html.erb
<%= form_with(model: tournament, local: true) do |f| %>
    <p>
      Name: <%= f.text_field :name, class: 'form-control' %>
    </p>
    <div class="row">

    <% Tournament::SCALE.times do %>
        <div class="col-12 col-md-3">
          <%= f.fields_for :teams, Team.new do |task_form| %>
              <p>
                Team name: <%= task_form.text_field :name, class: 'form-control' %>
              </p>
          <% end %>
        </div>
    <% end %>
    </div>
    <p>
      <%= f.submit 'Create Tournament', class: 'btn btn-outline-success' %>
    </p>
<% end %>

app/views/tournaments/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Tournaments</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @tournaments.each do |tournament| %>
      <tr>
        <td><%= tournament.name %></td>
        <td><%= link_to 'Show', tournament %></td>
        <td><%= link_to 'Edit', edit_tournament_path(tournament) %></td>
        <td><%= link_to 'Destroy', tournament, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Tournament', new_tournament_path %>

app/views/tournaments/new.html.erb
<h1>New Tournament</h1>

<%= render 'form', tournament: @tournament %>

app/views/tournaments/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @tournament.name %>
</p>

<%= link_to 'Edit', edit_tournament_path(@tournament) %> |
<%= link_to 'Back', tournaments_path %>

app/views/welcome/index.html.erb
<% if @tournament.present? %>
  <h1><%= @tournament.name %>
      <%= link_to 'Generate group', tournament_groups_path(@tournament), method: :post, class: 'btn btn-outline-success' if group_can_be_generated?(@tournament) %>
      <%= link_to 'Destroy all', clean_path, method: :delete, class: 'btn btn-outline-dark' %>
  </h1>
    <div class="row d-flex align-items-stretch">
          <% @tournament.teams.each do |team| %>
            <%= render team %>
          <% end %>
    </div>

    <div class="row d-flex align-items-stretch">
        <% @tournament.groups.each do |group| %>
          <%= render group %>
        <% end %>
    </div>

<% else %>

    <%= render 'layouts/welcome_jumbotron' %>

<% end %>